// Generated by Together

package com.itpath.framework.platform;
                                                                         
import com.itpath.framework.platform.interfaces.DataServices;
import com.itpath.framework.platform.interfaces.BusinessServices;
import com.itpath.framework.platform.interfaces.PresentationServices;
import com.itpath.framework.platform.interfaces.ExceptionServices;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.io.FileNotFoundException;
import java.lang.reflect.Constructor;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Properties;
import java.util.Vector;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Statement;
import java.sql.ResultSet;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.itpath.framework.business.BusinessRules;
import com.itpath.framework.business.BusinessObject;
import com.itpath.framework.business.DefaultBusinessObject;
import com.itpath.framework.data.DataObject;
import com.itpath.framework.data.DefaultDataObject;
import com.itpath.framework.exceptions.ExceptionObject;
import com.itpath.framework.presentation.PresentationRules;
import com.itpath.framework.presentation.PresentationObject;
import com.itpath.framework.presentation.DefaultPresentationObject;

public class ProxyServlet extends javax.servlet.http.HttpServlet 
  implements DataServices, BusinessServices, PresentationServices, ExceptionServices
{
  private String _sActionName = null;
  private Hashtable _hFormData = null;
  private PresentationObject _presentationObject = null;
  private DataObject _dataObject = null;
  private BusinessObject _businessObject = null;
  private HttpServletRequest _request = null;
  private HttpServletResponse _response = null;

  private Connection _connection = null;
  
  // BusinessServices -------------------------------------------
  
  public Hashtable getFormData()
  {
    String sUserValue = null;
    
    _hFormData = new Hashtable();

    // Retrieve the parameters from the HttpServletRequest...
    Enumeration eFormDataKeys = _request.getParameterNames();
    
    while (eFormDataKeys.hasMoreElements() )
    {
      String sCurrentKey = (String) eFormDataKeys.nextElement();
      
      if (sCurrentKey.startsWith(BusinessRules.Framework) )
      {
        String[] sUserValues = _request.getParameterValues( sCurrentKey);
        sUserValue = new String( sUserValues[0]);
        
        // take the values out of the array and put them in ; delimited order
        for ( int i = 1; i < sUserValues.length; i++)
        {
          sUserValue += ";" + sUserValues[i];
        }

        _hFormData.put(sCurrentKey, sUserValue);
      }
    }

    return _hFormData;
  }
  
  public PresentationObject getPresentationObject(String sActionName) throws Exception
  {
    // Can use reflection here also if you want to...
    
    
    _presentationObject = new DefaultPresentationObject(sActionName, (PresentationServices) this);

    return _presentationObject;
  }
  
  public DataObject getDataObject(String sActionName)
  {
    // Can use reflection here also if you want to....    
    _dataObject = new DefaultDataObject(sActionName, (DataServices) this);

    return _dataObject;
  }
  
  public BusinessObject getBusinessObject(String sActionName)
  {
    BusinessObject businessObject = null;

    // capitalize first character in actionName
    String firstChar = sActionName.substring( 0, 1 ).toUpperCase();
    
    sActionName = firstChar + sActionName.substring( 1 );
        
    String businessObjClass = BusinessRules.packageRoot
                              + "."
                              + PresentationRules.fieldHeader
                              + sActionName
                              + BusinessRules.businessObject;

    try
    {
      Class c = Class.forName( businessObjClass );

      // Create the arguments contained in the constructor
      Class args[] = new Class[1];
      args[0] = sActionName.getClass();

      // get the constructor from the class
      Constructor con = c.getConstructor( args );

      // create the arguments for the constructor
      Object[] parameters = new Object[1];
      parameters[0] = sActionName;

      // create the constructor with the fieldData parameter
      businessObject = ( BusinessObject ) con.newInstance( parameters );

    } catch ( Exception  e )
    {
      // Load the default business object
      businessObject = (BusinessObject) (new DefaultBusinessObject(sActionName)) ;
    }

     return businessObject;
  }

  public void initializeBusinessObject( BusinessObject businessObject)
  {
    try
    {
      businessObject.init(_hFormData, (BusinessServices) this);
    }
    catch (Exception e)
    {
      // handle the exception
      handleException(e);
    }
  }

  // PresentationServices ---------------------------------------
  public void evaluateTemplate(String pageName, Hashtable pageData) throws Exception
  {
    
    // format = <FIELD="FWState">

    BufferedReader brTemplateFile = null;

    // attempt to load the page
    brTemplateFile = new BufferedReader( new FileReader( pageName ) );

    // Initialize local variables
    StringBuffer strBuf = new StringBuffer();
    
    String sCurrentLine = null;
    int iFieldLocation = -1;
    String updatedLine = null;
    int iStartLocation = -1;
    int iStopLocation = -1;
    String sField = null;
    Object oFieldValue = null;
    String sFieldValue = null;
    String beginLine = null;
    String endLine = null;
    String line = null;
    
    // parse over each line
    while ( ( line = brTemplateFile.readLine() ) != null)
    {

      // create the updated line variable
      updatedLine = line;
      
      // look for the FIELD tag
      while ( (iFieldLocation = updatedLine.indexOf( PresentationRules.FIELD) ) != -1)
      {
        // find the quoted string value
        iStartLocation = updatedLine.indexOf( PresentationRules.QUOTE, iFieldLocation);        
        iStopLocation = updatedLine.indexOf( PresentationRules.QUOTE, iStartLocation + 1);
        
        if ( iStopLocation > iStartLocation)
        {         
          sField = updatedLine.substring(iStartLocation + 1, iStopLocation);
        }
        
        // check the hashtable for the quoted string
        oFieldValue = pageData.get( sField);
     
        // fill in the value if it's present
        sFieldValue = fillValue( oFieldValue); // as a quick solution for the reporting, should be expanded.

        // modify the updated line
        beginLine = updatedLine.substring( 0, iFieldLocation - PresentationRules.BEGIN.length() );
        endLine = updatedLine.substring( iStopLocation + PresentationRules.END.length() +1 );
        
        updatedLine = beginLine + sFieldValue + endLine;
      }
      
      // add the line to the buffer
      strBuf.append( updatedLine );
    }
    
    // retrieve the output stream from the response
    PrintWriter pw = _response.getWriter();
    
    // output the buffer to the response
    pw.println( strBuf.toString() );    
  }

  private String fillValue(Object oFieldValue) throws Exception
  {
    // initialize a temporary value for the vector fields
    StringBuffer strBuf = new StringBuffer();
    String line = new String();
    
    if ( oFieldValue == null)
    {
      return "";
    } 
    else if ( oFieldValue instanceof String)
    {      
      return (String) oFieldValue;
    }
    else if ( oFieldValue instanceof Vector)
    {
      Enumeration enumLines = ( (Vector) oFieldValue ) .elements();

      Vector newVector = new Vector();
      Object oElement = null;
      
      // cycle over all elements
      while ( enumLines.hasMoreElements() )
      {
        // because this is a simple template engine, I've assumed that all the fields in the vector are to be
        // displayed as table cells.
        oElement = enumLines.nextElement();
        
        if ( oElement instanceof Vector)
        {
          newVector = (Vector) oElement;
          
          Enumeration eNewVector = newVector.elements();
          String value = null;
          
          while ( eNewVector.hasMoreElements() )
          {
            value = (String) eNewVector.nextElement();
            
            line += PresentationRules.CellStart + value + PresentationRules.CellEnd;
          } 
        }
        else
        {
          throw new Exception( "Poorly formatted data");
        }
        
        strBuf.append(line);
      }
    }   
    return strBuf.toString();
  }
  
    
  public void service(HttpServletRequest request, HttpServletResponse response)
  {
    // Store the values of the request and the response
    _request = request;
    _response = response;
    
    // create formData Hashtable (sets the httpRequest flag)
    _hFormData = this.getFormData();

    // get actionName from the formData
    if ( _hFormData.get(BusinessRules.ACTION_NAME) instanceof String )
    {
      _sActionName = (String) _hFormData.get(BusinessRules.ACTION_NAME);
    }

    // If the action name is null (the user has attempted to access from a
    // bookmarked page).
    if ( _sActionName == null)
    {
      // set the action name
      _sActionName = PresentationRules.REPORT;

      try
      {
        // get a handle to the presentation object
        PresentationObject presentation = getPresentationObject( _sActionName);

        // add the page name to the session
        Hashtable pageData = new Hashtable();
        pageData.put( PresentationRules.PAGE_NAME, PresentationRules.REPORT);

        // show the login screen
        presentation.showPage( pageData);
      }
      catch ( Exception ue)
      {
        handleException(ue);
      }
    }

    // get the business object from the action name
    _businessObject = getBusinessObject(_sActionName);

    // initialize the business object
    initializeBusinessObject( _businessObject );
  }

  public void handleException(Exception e)
  {
    // Handle the exception by creating a new ExceptionObj to
    // perform the required action
    new ExceptionObject( e, (ExceptionServices)this );
  }

// DataServices -------------------------------------------------
  public Connection openConnection(String driver, String url, String user, String password) 
    throws Exception
  {
    // hardcoded for the example...
    driver = ("sun.jdbc.odbc.JdbcOdbcDriver");
    url = "jdbc:odbc:framework";
    user = "";
    password = "";

    try
    {
      Class.forName(driver);

      _connection = DriverManager.getConnection(url,user,password);
    }
    catch (Exception e)
    {
      handleException(e);
    }

    return _connection;
  }
    
  public Vector execute(String sqlString) throws Exception
  {
    Vector vReturnVector = new Vector();//todo

    // left to the user since it involves basic jdbc functionality.
    
    return vReturnVector;
  }

  private void closeDatabase() throws Exception
  {
    getConnection();
    
    _connection.close();
  }

  public int startTransaction() throws Exception
  {
    getConnection();
    
    _connection.setAutoCommit(false);

    return 0;
  }

  public int commitTransaction() throws Exception
  {
    getConnection();
    
    _connection.commit();

    return 0;
  }

  public int rollbackTransaction() throws Exception
  {
    getConnection();
    
    _connection.rollback();

    return 0;
  }
  
  private void getConnection() throws Exception
  {
    if ( _connection == null)
    {
      openConnection("","","","");
    }
  }
}

