package com.itpath.security;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.IOException;
import java.util.*;

public class BaseServlet extends HttpServlet
{
	public void service(HttpServletRequest request, HttpServletResponse response)
		throws IOException, ServletException
	{
		// check to see if a session has already been created for this user
		//		don't create a new session yet.
		HttpSession session = request.getSession( false);

		String requestedPage = request.getParameter(Constants.REQUEST);

		if ( session != null)
		{
			// retrieve authentication parameter from the session
			Boolean isAuthenticated = (Boolean) session.getValue(Constants.AUTHENTICATION);

			// if the user is not authenticated
			if ( !isAuthenticated.booleanValue() )
			{
				// process the unauthenticated request
				unauthenticatedUser(response, requestedPage);
			}
		}
		else // the session does not exist
		{
			// therefore the user is not authenticated
			// process the unauthenticated request
			unauthenticatedUser(response, requestedPage);
		}
	}

	private void unauthenticatedUser(HttpServletResponse response, String requestedPage)
		throws IOException
	{
		// redirect to the login servlet (passing parameter)
		response.sendRedirect( Constants.LOGIN + requestedPage);
	}
}