package com.itpath.security;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.IOException;
import java.util.*;

public class BaseServlet2 extends HttpServlet
{
	public void service(HttpServletRequest request, HttpServletResponse response)
		throws IOException, ServletException
	{
		// check to see if a session has already been created for this user
		//		don't create a new session yet.
		HttpSession session = request.getSession( false);

		String sRequestedFeature = request.getParameter(Constants.FEATURE);

		if ( session != null)
		{
			// retrieve the User object from the session
			User currentUser = (User) session.getValue(Constants.USER);

			Feature featureRequested = null;
			try
			{
				// get the page from the security manager
				featureRequested = WebSecurityManager.getFeature( sRequestedFeature);
			}
			catch ( WebSecurityManagerException smE)
			{
				smE.printStackTrace();
			}

			if ( WebSecurityManager.isUserAuthenticated( currentUser, featureRequested) )
			{
				// get page from feature
				String sRequestedPage = featureRequested.getFeaturePath();

				// redirect to the requested page
				response.sendRedirect( Constants.LOGIN2 + sRequestedPage);
			}
			else
			{
				// redirect to the error page
				response.sendRedirect( Constants.ERROR + sRequestedFeature);
			}
		}
		else
		{
			// redirect to the login servlet (passing parameter)
			response.sendRedirect( Constants.LOGIN2 + sRequestedFeature);
		}
	}
}