package com.itpath.security;

import java.util.*;
import java.security.Principal;
import java.security.acl.*;
import sun.security.acl.*;

public class UserImpl implements User
{
	private String _sUserID = null;
	private Hashtable _hUserInformation = null;;
	private Vector _vUserFeatures = null;

	private Principal _principal = null;

	public UserImpl(String sUserID, Hashtable hUserInformation)
	{
		// Store the userID in a class variable
		_sUserID = sUserID;

		// create the PrincipalImpl delegate object
		_principal = new PrincipalImpl( sUserID);

		// if the hashtable is not null
		if ( hUserInformation != null )
		{
			// store the information in the class variable
			_hUserInformation = hUserInformation;
		} else {
			// otherwise, store an empty hashtable
			_hUserInformation = new Hashtable();
		}
	}

	/* from User */
	public String getPhoneNumber()
	{
		// Error handling if the hashtable does not contain a PHONENUMBER
		if ( !_hUserInformation.contains( Constants.PHONENUMBER) )
		{
			return null;
		}

		// return the value stored in the hashtable
		return (String) _hUserInformation.get(Constants.PHONENUMBER);
	}

	/* from Principal */
	public boolean equals(Object object)
	{
		return _principal.equals(object);
	}

	public String getName()
	{
		return _principal.getName();
	}

	public int hashCode()
	{
		// return a hashcode of the userID
		return _principal.hashCode();
	}

	public String toString()
	{
		return _principal.toString();
	}

}