package com.itpath.security;

public class UserNotFoundException extends Exception
{
	private String _sGroupId = null;
	private String _sUserId = null;
	private String _sAction = null;
	private String _sMessage = null;
	private Exception _exception = null;

	public UserNotFoundException(String sGroupId, String sUserId, String sAction, Exception exception)
	{
		// store the passed in values in class variables
		_sGroupId = sGroupId;
		_sUserId = sUserId;
		_sAction = sAction;
		_exception = exception;

		// generate the message upon initialization
		_sMessage = "The user "+ _sUserId +" belonging to group "+ _sGroupId +" was not found for action "+ _sAction+".";

	}

	public String getMessage()
	{
		// return the message to the user
		return _sMessage;
	}

	public void printStackTrace()
	{
		// output the message & print the StackTrace
		System.out.println( _sMessage);
		_exception.printStackTrace();
	}
}